CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  cols = 32 '0-31=32
  rows = 16 '0-15=16
  


OBJ
  mouse   : "mouse"
  text : "vga_text_PY"

'' Output a character                         
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
'' 10  $0A = set X position (X follows)
'' 11  $0B = set Y position (Y follows)
'' 12  $0C = set color (color follows)
'' 13  $0D = return
''  others = printable characters
  
VAR
 byte  cx0, cy0, charC
 word charW
 Long CharL
 
PUB VgaTextDemoStart | i

  'start mouse and set bound parameters
  mouse.start(24, 25)
  mouse.bound_limits(0, 0, 0, cols - 1, rows - 1, 0)
  mouse.bound_scales(2, -3, 0)

  'start term
  text.start(16)                'basepin=16
  text.str(string(13," VGA Text Demo with mouse info",13,13,$C,5,"OBJ and VAR require only 2.6KB ?",$C,1))
  
  repeat i from 0 to 13        'output 14 special characters that are commands for text.out( )
    text.print(i)              'was PRI now PUB
    
  repeat i from $0E to $FF      'output all other characters
    text.out(i)
  text.str(string($C,6,"     Uses internal ROM font     ",$C,2))
  
  repeat
    cx0 := mouse.bound_x        'get mouse data
    cy0 := mouse.bound_y
  
    text.str(string($A,1,$B,14))  'set location
    text.hex(cx0, 2)              'x pos
    text.str(string($A,4,$B,14)) 'set location
    text.hex(cy0, 2)              'y pos
    text.str(string($A,10,$B,14)) 'set location
    text.bin(charW,16)           'character data
    
    text.out($A)                'set location to mouse position
    text.out(cx0)
    text.out($B)
    text.out(cy0)
    charL := text.printC("_")    'indicate mouse location
  
    repeat 10000                'wait longenough to see cursor change

   charW := charL 
   text.printC(charW)           'restore chatacter at cutsor location (initaly "A" is returned to test program)
                                'trouble "A" is printed in next position not original position.

  
  ' how do you read the character at the current position befor out clobers it?
  